
#include "os_inc.h"

//
//	OS-Specific calls
//

void OS_DbgMsg( unsigned char *szFormat, ... )
{
#ifdef ALSA_DEBUG
	char		szBuf[ 128 ];
	va_list		arglist;

	va_start( arglist, szFormat );

	vsprintf( szBuf, szFormat, arglist );

	va_end( arglist );

	printk ( szBuf );
#endif
}

void * OS_AllocateMemory (unsigned long Size)
{
	return kmalloc( Size, GFP_KERNEL ); 
}

void * OS_AllocateDMAMemory (void* pAdapterObject, unsigned long Size, unsigned long *PhysicalAddress)
{	 
	unsigned int	NumberOfPages;
	unsigned long	*VirtualAddress;
		
	NumberOfPages=Size/1024;

	VirtualAddress = snd_malloc_pages(Size, NULL, GFP_KERNEL|GFP_DMA);

	*PhysicalAddress = virt_to_bus(VirtualAddress);

	return VirtualAddress;
}

void OS_FreeDMAMemory (void* pAdapterObject, void * VirtualAddress, unsigned long PhysicalAddress, unsigned long Size)
{
	snd_free_pages(VirtualAddress, Size);
}

unsigned long OS_ReadPortULong(unsigned short Port)
{
	return inl((int) Port);
}

void OS_WritePortULong (unsigned short Port, unsigned long Data)
{
	outl (Data, (int) Port);
}

unsigned short OS_ReadPortUShort (unsigned short Port)
{
	return inw((int) Port);
}

void OS_WritePortUShort (unsigned short Port, unsigned short Data)
{
	outw (Data, (int) Port);
}

unsigned char OS_ReadPortUChar (unsigned short Port)
{
	return inb((int) Port);
}

void OS_WritePortUChar (unsigned short Port, unsigned char Data)
{
	outb (Data, (int) Port);
}

unsigned long OS_VirtualAddress (unsigned long PhysicalAddress)
{
	return (unsigned long) phys_to_virt (PhysicalAddress);
}

unsigned long OS_Get_F3BAR0_Virt(unsigned long BAR_Phys)
{
	unsigned long F3BAR_Virt;

	F3BAR_Virt=(unsigned long) ioremap(BAR_Phys,256);

	return F3BAR_Virt;
}

void OS_Free (unsigned char *pucBuff)
{
//	ExFreePool( pucBuff );
}

void OS_Sleep (unsigned long milliseconds)
{
/*
	LARGE_INTEGER	SysTimeout;

	if( KeGetCurrentIrql() >= DISPATCH_LEVEL )
	{
		ULONG	Cnt = 20 * milliseconds;
		while( Cnt-- )
		{
			//	KeStallExecutionProcessor: counted in us
			KeStallExecutionProcessor( 50 );
		}
	}
	else
	{
		SysTimeout.QuadPart = (LONGLONG)-10 * 1000 * milliseconds;
		//	KeDelayExecutionThread: counted in 100 ns
		KeDelayExecutionThread( KernelMode, FALSE, &SysTimeout );
	}
*/
}
