//
// Copyright (c) national Semiconductor Corporation.  All rights reserved.
//
//
//  Module Name:  
//  
//      os_inc.h
//  
//  Abstract:  
//
//    DURAUDIO - OS specific defines
//  
//  Functions:
//  
//  Notes:
//  
// -----------------------------------------------------------------------------
#ifndef __OS_INC_H__
#define __OS_INC_H__

#include <linux/types.h>

//#define ALSA_DEBUG	TRUE

//
//		DMA Buffer constants
//

#define AUDIO_DMA_BUFFER_SIZE                   8192
#define AUDIO_DMA_CHANNELS                      2
#define AUDIO_DMA_PAGE_SIZE                     2048
#define AUDIO_DMA_PAGES                         (AUDIO_DMA_BUFFER_SIZE / AUDIO_DMA_PAGE_SIZE)

#define	SIZE_OF_EACH_PRD_BLOCK		32			//  Each PRD entry will point to 64 bytes (16 samples) of the DMA buffer

//
//  Device and Vendor IDs - Needed like this for OSS only
//
#define CYRIX_VENDOR_ID     0x1078   
#define NATIONAL_VENDOR_ID  0x100B   

//
//       Audio  Device IDs
//
#define	CX5530_DEV_ID    0x0103
#define	SC1200_DEV_ID    0x0503
#define	CS5535_DEV_ID    0x002E

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/ctype.h>
#include <linux/ioport.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/sound.h>
#include <linux/slab.h>
#include <linux/soundcard.h>
#include <linux/pci.h>

#include <linux/init.h>
#include <linux/poll.h>
#include <asm/uaccess.h>
#include <asm/hardirq.h>
#include <asm/io.h>
#include <asm/dma.h>

//---------------------------
//		  OS-Specific
//---------------------------

void			OS_DbgMsg				( unsigned char *szFormat, ... );

unsigned long	OS_ReadPortULong		(unsigned short Port);
unsigned short	OS_ReadPortUShort		(unsigned short Port);
void			OS_WritePortULong		(unsigned short Port, unsigned long  Data);
void			OS_WritePortUShort		(unsigned short Port, unsigned short Data);

unsigned char	OS_ReadPortUChar		(unsigned short Port);
void			OS_WritePortUChar		(unsigned short Port, unsigned char Data);

void*			OS_AllocateMemory		(unsigned long Size);
void*			OS_AllocateDMAMemory	(void* pAdapterObject, unsigned long Size, unsigned long *PhysicalAddress);
void			OS_FreeDMAMemory		(void* pAdapterObject, void* VirtualAddress, unsigned long PhysicalAddress, unsigned long Size);

unsigned long	OS_VirtualAddress		(unsigned long PhysAddress);
unsigned long	OS_Get_F3BAR0_Virt		(unsigned long BAR_Phys);
void			OS_Free					(unsigned char *pucBuff);
void			OS_Sleep				(unsigned long Delay);


#endif	//  __OS_INC_H__
